
#include <windows.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <stdio.h>

void cls()
{
    CONSOLE_SCREEN_BUFFER_INFO csbi;
    HANDLE con = GetStdHandle(STD_OUTPUT_HANDLE);
    GetConsoleScreenBufferInfo(con, &csbi);
    unsigned long n;
    COORD c = {0, 0};
    FillConsoleOutputCharacter(con, ' ', csbi.dwSize.X * csbi.dwSize.Y, c, 
&n);
    SetConsoleCursorPosition(con, c);
}

int Check(char *buf, int len)
{
	for(int i=0; i < len; i++)
		if(buf[i] > 9)
			return i+1;
	return 0;
}

int MainMenu()
{
    char c;
    cls();
    printf("\tM A I N   M E N U\n[1] Check a number.\n[2] Complete a number.\n[3] Quit.\n");
    do{
        scanf("%1c", &c);
        if(c == '3') exit(0);
    }while((c != '1') && (c != '2'));
    cls();
    return c;
}

void GetNumber(int n, char *buf)
{
    printf("Enter a number (%d digits): ", n);
    char fmtString[30] = "%";
    itoa(n, fmtString+1, 10);
    fmtString[strlen(fmtString)+1] = 0;
    fmtString[strlen(fmtString)] = 's';
    scanf(fmtString, buf);
    for(int i=0; i<n; i++)
        buf[i] = buf[i] - 0x30;
}

bool check_num(char *buf)
{
    long unsigned sum = 0;
    for(int i=0; i<14; i++)
        sum += (unsigned long)pow(buf[i], 13-i);
    return ( (sum%7) == (unsigned long)buf[14] );
}

void complete_num(char *buf)
{
    int sum = 0;
    for(int i=0; i<14; i++)
        sum += (unsigned long)pow(buf[i], 13-i);
    buf[14] = sum%7;
}

int main(int argc, char* argv[])
{
    char n[15];
    int c;
	int p;
    do{
        c = MainMenu();
		do{
			GetNumber(sizeof(n) + 0x31 - c, n);
			p = Check(n, sizeof(n));
            if(p){
                printf("%*s%c\nIncorrect number.\n\n", p + 27, "", '^');
            }
        }while(p);

        switch(c){
            case '1':
                printf("The number %1d%1d%1d%1d%1d%1d%1d%1d%1d%1d%1d%1d%1d%1d%1d is ",
                        n[0], n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14]);
                if(check_num(n))
                    printf("correct.\n");
                else
                    printf("incorrect.\n");
                break;
            case '2':
                complete_num(n);
                printf("The number is %1d%1d%1d%1d%1d%1d%1d%1d%1d%1d%1d%1d%1d%1d%1d\n",
                        n[0], n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14]);
                break;
        }
        printf("\nPress 'Enter' to continue.\n");
        getch();
    }while(1);

    return 0;
}


