
#include <windows.h>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>

void cls()
{
    CONSOLE_SCREEN_BUFFER_INFO csbi;
    HANDLE con = GetStdHandle(STD_OUTPUT_HANDLE);
    GetConsoleScreenBufferInfo(con, &csbi);
    unsigned long n;
    COORD c = {0, 0};
    FillConsoleOutputCharacter(con, ' ', csbi.dwSize.X * csbi.dwSize.Y, c, 
&n);
    SetConsoleCursorPosition(con, c);
}

int Check(char *buf, int len)
{
	for(int i=0; i < len-1; i++)
		if(buf[i] > 9)
			return i+1;
    if((buf[len-1] > 9) && (buf[len-1]+0x30 != 'X') && (buf[len-1]+0x30 != 'x'))
		return len;
    return 0;
}

int MainMenu()
{
    char c;
    cls();
    printf("\tM A I N   M E N U\n[1] Check a number.\n[2] Complete a number.\n[3] Quit.\n");
    do{
        scanf("%1c", &c);
        if(c == '3') exit(0);
    }while((c != '1') && (c != '2'));
    cls();
    return c;
}

void GetNumber(int n, char *buf)
{
    printf("Enter a number (%d digits): ", n);
    char fmtString[30] = "%";
    itoa(n, fmtString+1, 10);
    fmtString[strlen(fmtString)+1] = 0;
    fmtString[strlen(fmtString)] = 's';
    scanf(fmtString, buf);
    for(int i=0; i<n; i++)
        buf[i] = buf[i] - 0x30;
}

bool check_num(char *buf)
{
    int sum = 0;
    for(int i=0; i<9; i++)
        sum += buf[i] * (10 - i);
    if((buf[9] == ('X'-0x30)) || (buf[9] == ('x'-0x30)))
        sum += 10;
    else
        sum += buf[9];
    return ( !(sum%11) );
}

void complete_num(char *buf)
{
    int sum = 0;
    for(int i=0; i<9; i++)
        sum += buf[i] * (10 - i);
    buf[9] = (11 - sum%11)%11;
    if(buf[9] == 10)
        buf[9] = 'X';
}

int main(int argc, char* argv[])
{
    char n[10];
    int c;
	int p;
    do{
        c = MainMenu();
		do{
			GetNumber(sizeof(n) + 0x31 - c, n);
			p = Check(n, sizeof(n));
            if(p){
                printf("%*s%c\nIncorrect number.\n\n", p + 76 - c, "", '^');
            }
        }while(p);

        switch(c){
            case '1':
                printf("The number %1d%1d%1d%1d%1d%1d%1d%1d%1d%c is ",
                        n[0], n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], (n[9] == 10)?'X':n[9]+0x30);
                if(check_num(n))
                    printf("correct.\n");
                else
                    printf("incorrect.\n");
                break;
            case '2':
                complete_num(n);
                printf("The number is %1d%1d%1d%1d%1d%1d%1d%1d%1d%c\n",
                        n[0], n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], (n[9] == 10)?'X':n[9]+0x30);
                break;
        }
        printf("\nPress 'Enter' to continue.\n");
        getch();
    }while(1);
    return 0;
}


