
#include <windows.h>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>

char tab[10] = {0,2,4,6,8,1,3,5,7,9};

void cls()
{
    CONSOLE_SCREEN_BUFFER_INFO csbi;
    HANDLE con = GetStdHandle(STD_OUTPUT_HANDLE);
    GetConsoleScreenBufferInfo(con, &csbi);
    unsigned long n;
    COORD c = {0, 0};
    FillConsoleOutputCharacter(con, ' ', csbi.dwSize.X * csbi.dwSize.Y, c, 
&n);
    SetConsoleCursorPosition(con, c);
}

int Check(char *buf, int len)
{
	for(int i=0; i < len; i++)
		if(buf[i] > 9)
			return i+1;
	return 0;
}

int MainMenu()
{
    char c;
    cls();
    printf("\tM A I N   M E N U\n[1] Check a number.\n[2] Complete a number.\n[3] Quit.\n");
    do{
        scanf("%1c", &c);
        if(c == '3') exit(0);
    }while((c != '1') && (c != '2'));
    cls();
    return c;
}

int GetNumber(char *buf)
{
    printf("Enter a number: ");
    scanf("%s", buf);
    int i = 0;
    while(buf[i]){
        buf[i] = buf[i] - 0x30;
        i++;
    }
    return i;
}

bool check_num(int n, char *buf)
{
    int sum = 0;
    int f = n%2;
    for(int i=0; i<n; i++){
        sum += (f?buf[i]:tab[buf[i]]);
        f = !f;
    }
    return ( !(sum%10) );
}

void complete_num(int n, char *buf)
{
    int sum = 0;
    int f = (n+1)%2;
    for(int i=0; i<n; i++){
        sum += (f?buf[i]:tab[buf[i]]);
        f = !f;
    }
    buf[n] = (10 - sum%10)%10;
}

int main(int argc, char* argv[])
{
    char n[1024];
    int len, c, i;
	int p;
    do{
        c = MainMenu();
		do{
            len = GetNumber(n);
			p = Check(n, len);
            if(p){
                printf("%*s%c\nIncorrect number.\n\n", p + 15, "", '^');
            }
        }while(p);

        switch(c){
            case '1':
                printf("The number ");
                for(i=0; i<len; i++)
                    printf("%1d", n[i]);
                if(check_num(len, n))
                    printf(" is correct.\n");
                else
                    printf(" is incorrect.\n");
                break;
            case '2':
                complete_num(len, n);
                printf("The number is ");
                for(i=0; i<len+1; i++)
                    printf("%1d", n[i]);
                printf("\n");
                break;
        }
        printf("\nPress 'Enter' to continue.\n");
        getch();
    }while(1);
    return 0;
}


